/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.data;

import android.content.Context;
import android.database.Cursor;
import android.provider.ContactsContract.CommonDataKinds.Phone;
import android.provider.ContactsContract.Data;
import android.telephony.PhoneNumberUtils;
import android.util.Log;

import java.util.HashMap;

public class Contact {
    private static HashMap<String, String> sContactCache;// 用于缓存已查询过的联系人信息
    private static final String TAG = "Contact";// 用于日志输出的 TAG

    // 查询电话号码与联系人名字匹配的过滤条件
    private static final String CALLER_ID_SELECTION = "PHONE_NUMBERS_EQUAL(" + Phone.NUMBER
    + ",?) AND " + Data.MIMETYPE + "='" + Phone.CONTENT_ITEM_TYPE + "'"
    + " AND " + Data.RAW_CONTACT_ID + " IN "
            + "(SELECT raw_contact_id "
            + " FROM phone_lookup"
            + " WHERE min_match = '+')";
    /*
     * 获取电话号码对应的联系人名字
     * @param context 上下文
     * @param phoneNumber 电话号码
     * @return 电话号码对应的联系人名字
     */
    public static String getContact(Context context, String phoneNumber) {
        // 如果缓存为空，创建新的缓存对象
        if(sContactCache == null) {
            sContactCache = new HashMap<String, String>();
        }

        // 如果已经查询过该电话号码，直接返回缓存中的联系人名字
        if(sContactCache.containsKey(phoneNumber)) {
            return sContactCache.get(phoneNumber);
        }

        // 构造查询条件
        String selection = CALLER_ID_SELECTION.replace("+",
                PhoneNumberUtils.toCallerIDMinMatch(phoneNumber));
        Cursor cursor = context.getContentResolver().query(
                Data.CONTENT_URI,
                new String [] { Phone.DISPLAY_NAME },
                selection,
                new String[] { phoneNumber },
                null);

        // 如果能够查询到联系人信息
        if (cursor != null && cursor.moveToFirst()) {
            try {
                String name = cursor.getString(0);
                // 将电话号码与联系人名字加入缓存中
                sContactCache.put(phoneNumber, name);
                return name;
            } catch (IndexOutOfBoundsException e) {
                Log.e(TAG, " Cursor get string error " + e.toString());
                return null;
            } finally {
                cursor.close();// 关闭查询结果游标
            }
        } else {// 如果未能查询到联系人信息，输出日志并返回 null
            Log.d(TAG, "No contact matched with number:" + phoneNumber);
            return null;
        }
    }
}